
/* 
 ================================================
 PVII Background Scroll Effects scripts
 Copyright (c) 2019 Project Seven Development
 www.projectseven.com
 Version: 1.0.6 -build 07
 ================================================
 
 */
var p7BSE = {
	ctl: [],
	once: false,
	legacy: false,
	currScroll: 0,
	prevScroll: -1,
	winH: 0,
	scrollDir: 'down',
	ie: false,
	prf: 'none'
};
function P7_BSEbb(){
}

function P7_BSEaddLoad(){
	if (window.addEventListener) {
		document.addEventListener("DOMContentLoaded", P7_BSEinit, false);
		window.addEventListener("load", P7_BSEinit, false);
		window.addEventListener("unload", P7_BSEbb, false);
		window.addEventListener("scroll", P7_BSEscroll, false);
		window.addEventListener("resize", P7_BSErsz, false);
	} else if (window.attachEvent) {
		window.attachEvent("onload", P7_BSEinit);
		window.attachEvent("onunload", P7_BSEbb);
		window.attachEvent("scroll", P7_BSEscroll);
		window.attachEvent("onresize", P7_BSErsz);
	}
}

P7_BSEaddLoad();
function P7_BSEinit(){
	var cT, j, op, tB, sy, el, cl, tlc, tA, i, x, y, sc, range;
	if (p7BSE.once) {
		return;
	}
	p7BSE.once = true;
	p7BSE.prf = P7_BSEgetCSSPre();
	cT = P7_BSEgetByAttribute('data-bse-body', 'bse-list');
	if (cT && cT[0]) {
		el = document.body;
		el.setAttribute('data-bse', cT[0].getAttribute('data-bse'));
		P7_BSEsetClass(el, 'bse-bg');
		cT[0].removeAttribute('data-bse');
	}
	cT = P7_BSEgetByAttribute('data-bse', 'bse-bg');
	for (j = 0; j < cT.length; j++) {
		op = cT[j].getAttribute('data-bse').split(',');
		tB = document.getElementById('p7BSE_' + op[0]);
		tB.bseOpt = op;
		sy = P7_BSEgetStyle(cT[j], 'position');
		if (!sy || sy === '' || sy == 'static') {
			cT[j].style.position = 'relative';
		}
		P7_BSEremClass(tB, 'bse-noscript');
		p7BSE.ctl[p7BSE.ctl.length] = tB;
		if (tB.bseOpt[2] > 0 && p7BSE.prf == 'none') {
			tB.bseOpt[2] = 0;
		}
		op = tB.bseOpt[2];
		if (tB.bseOpt[7] == 1) {
			tB.bseMode = 'anim';
			tB.bseTransTrig = false;
		} else {
			tB.bseMode = 'bind';
		}
		el = document.createElement('span');
		cl = 'p7BSE bse-wrapper';
		if (cT[j].tagName == 'BODY') {
			cl += ' bse-body';
		}
		el.setAttribute('class', cl);
		cT[j].appendChild(el);
		tB.bseWrapper = el;
		el = document.createElement('span');
		el.setAttribute('class', 'bse-mask');
		tB.bseWrapper.appendChild(el);
		cl = tB.getAttribute('class');
		if (/bse\-rounded/.test(cl)) {
			P7_BSEsetClass(tB.bseWrapper, 'bse-rounded');
		}
		tlc = cl.match(/bse\-color\-[^\s]*\b/);
		if (tlc && tlc[0]) {
			P7_BSEsetClass(el, tlc[0]);
		}
		if (tB.bseOpt[6] > 0) {
			el.style.opacity = parseInt(tB.bseOpt[6], 10) / 100;
		}
		tB.bseFixed = false;
		if (P7_BSEgetStyle(tB.bseWrapper, 'position') == 'fixed') {
			tB.bseWrapper.bseFixed = true;
		}
		tA = tB.getElementsByTagName('A');
		if (tA && tA[0]) {
			cl = tA[0].className;
			if (cl && (/bse/.test(cl))) {
				el = document.createElement('span');
				el.className = 'bse-image ' + tA[0].className;
				tB.bseWrapper.appendChild(el);
				tB.bseOb = el;
				if (tB.bseOpt[7] == 1) {
					el.style[p7BSE.prf + 'transition'] = 'transform 0ms ease-out 0ms, scale 0ms ease-out 0ms';
				}
				el.style.backgroundImage = 'url("' + tA[0].getAttribute('href') + '")';
				range = tB.bseOpt[3];
				x = 0;
				y = 0;
				sc = 1;
				if (op > 6 && op < 11) {
					sc = 1 + ((tB.bseOpt[3] * 2) / 100);
				}
				if (op == 1 || op == 2) {
					x = (op == 1) ? 1 : (1 + (range / 100));
					el.style[p7BSE.prf + 'transform'] = 'scale(' + x + ')';
				} else if (op > 2 && op < 11) {
					if (op == 3 || op == 7) {
						x = range * -1;
					} else if (op == 4 || op == 8) {
						x = range;
					} else if (op == 5 || op == 9) {
						y = range * -1;
					} else if (op == 6 || op == 10) {
						y = range;
					}
					el.style[p7BSE.prf + 'transform'] = 'translate(' + x + '%,' + y + '%) scale(' + sc + ')';
					el.offsetWidth = el.offsetWidth;
				}
			}
		}
	}
	P7_BSEscroll();
}

function P7_BSErsz(){
	P7_BSEscroll();
}

function P7_BSEscroll(){
	var i, tB;
	p7BSE.winH = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
	p7BSE.prevScroll = p7BSE.currScroll;
	p7BSE.currScroll = document.body.parentNode.scrollTop || document.body.scrollTop || window.scrollY || 0;
	p7BSE.scrollDir = (p7BSE.currScroll >= p7BSE.prevScroll) ? 'down' : 'up';
	for (i = 0; i < p7BSE.ctl.length; i++) {
		tB = p7BSE.ctl[i];
		if (!tB.bseOnlyOnce) {
			if (tB.bseMode == 'anim') {
				P7_BSEscrollAnim(tB);
			} else {
				P7_BSEscrollBind(tB);
			}
		}
	}
}

function P7_BSEscrollAnim(tB){
	var x = 0, y = 0, sc = 1, tD, op, ro, br, tp, m = false, range, inView, dur;
	tD = tB.bseOb;
	op = tB.bseOpt[2];
	ro = (tB.bseOpt[1] == 1) ? true : false;
	br = tD.parentNode.getBoundingClientRect();
	tp = p7BSE.winH - (p7BSE.winH * (tB.bseOpt[5] / 100));
	if (!tB.bseOpenDone && p7BSE.scrollDir == 'down') {
		if (br.top <= tp) {
			tB.bseOpenDone = true;
			tB.bseCloseDone = false;
			m = true;
		}
	}
	if (!tB.bseCloseDone && p7BSE.scrollDir == 'up') {
		if (br.top >= tp) {
			tB.bseOpenDone = false;
			tB.bseCloseDone = true;
			m = true;
		}
	}
	if (m) {
		inView = true;
		if (br.top > p7BSE.winH || br.bottom < 0) {
			inView = false;
		}
		if (tB.bseOpt[1] == 1 && inView) {
			tB.bseOnlyOnce = true;
		}
		dur = (inView) ? tB.bseOpt[8] : 0;
		tD.style[p7BSE.prf + 'transition-duration'] = dur + 'ms';
		range = tB.bseOpt[3];
		if (op == 1 || op == 2) {
			if (op == 1) {
				if (p7BSE.scrollDir == 'down') {
					x = 1 + (range / 100);
				} else {
					x = 1;
				}
			} else {
				if (p7BSE.scrollDir == 'down') {
					x = 1;
				} else {
					x = 1 + (range / 100);
				}
			}
			tD.style[p7BSE.prf + 'transform'] = 'scale(' + x + ')';
		} else if (op > 2 && op < 11) {
			if (op > 6 && op < 11) {
				sc = 1 + ((tB.bseOpt[3] * 2) / 100);
			}
			if (op == 3 || op == 7) {
				if (p7BSE.scrollDir == 'down') {
					x = 0;
				} else {
					x = range * -1;
				}
			} else if (op == 4 || op == 8) {
				if (p7BSE.scrollDir == 'down') {
					x = 0;
				} else {
					x = range;
				}
			} else if (op == 5 || op == 9) {
				if (p7BSE.scrollDir == 'down') {
					y = 0;
				} else {
					y = range * -1;
				}
			} else if (op == 6 || op == 10) {
				if (p7BSE.scrollDir == 'down') {
					y = 0;
				} else {
					y = range;
				}
			}
			tD.style[p7BSE.prf + 'transform'] = 'translate(' + x + '%,' + y + '%) scale(' + sc + ')';
		}
	}
}

function P7_BSEscrollBind(tB){
	var tD, op, ro, br, wh, inView = false, x = 0, y = 0, sc = 1, ar, tf, bf, pc, ph, sr, tt, at, cs, max;
	tD = tB.bseOb;
	op = tB.bseOpt[2];
	wh = p7BSE.winH;
	ro = (tB.bseOpt[1] == 1) ? true : false;
	br = tD.parentNode.getBoundingClientRect();
	tt = br.top;
	ar = tB.bseOpt[3];
	tf = wh * (tB.bseOpt[4] / 100);
	bf = wh * (tB.bseOpt[5] / 100);
	if (op > 6 && op < 11) {
		sc = 1 + ((tB.bseOpt[3] * 2) / 100);
	}
	at = false;
	if (tt < (wh - bf)) {
		inView = true;
	}
	if (br.bottom < 0) {
		inView = false;
		at = true;
	}
	if (inView) {
		tB.bseOutView = false;
		pc = (tt - tf) / (wh - tf - bf);
		if (tD.parentNode.bseFixed) {
			ph = document.body.parentNode.offsetHeight || document.body.offsetHeight;
			sr = ph - wh;
			cs = p7BSE.currScroll;
			pc = cs / sr;
			pc = 1 - pc;
		}
		if (op == 1) {
			x = 1 + (ar * (1 - pc)) / 100;
			max = 1 + (ar / 100);
			x = (x > max) ? max : x;
			tD.style[p7BSE.prf + 'transform'] = 'scale(' + x + ')';
			if (ro && x >= max) {
				tB.bseOnlyOnce = true;
			}
		} else if (op == 2) {
			x = 1 + (ar * pc) / 100;
			x = (x < 1) ? 1 : x;
			tD.style[p7BSE.prf + 'transform'] = 'scale(' + x + ')';
			if (ro && x == 1) {
				tB.bseOnlyOnce = true;
			}
		} else if (op > 2 && op < 11) {
			if (op == 3 || op == 7) {
				ar = ar * -1;
				x = ar * pc;
				x = (x > 0) ? 0 : x;
				x = (x < ar) ? ar : x;
				if (ro && x === 0) {
					tB.bseOnlyOnce = true;
				}
			} else if (op == 4 || op == 8) {
				x = ar * pc;
				x = (x < 0) ? 0 : x;
				x = (x > ar) ? ar : x;
				if (ro && x === 0) {
					tB.bseOnlyOnce = true;
				}
			} else if (op == 5 || op == 9) {
				ar = ar * -1;
				y = ar * pc;
				y = (y > 0) ? 0 : y;
				y = (y < ar) ? ar : y;
				if (ro && y === 0) {
					tB.bseOnlyOnce = true;
				}
			} else if (op == 6 || op == 10) {
				y = ar * pc;
				y = (y < 0) ? 0 : y;
				y = (y > ar) ? ar : y;
				if (ro && y === 0) {
					tB.bseOnlyOnce = true;
				}
			}
			tD.style[p7BSE.prf + 'transform'] = 'translate(' + x + '%,' + y + '%) scale(' + sc + ')';
		}
	} else if (!tB.bseOutView) {
		tB.bseOutView = true;
		if (op == 1) {
			x = (at) ? 1 + (ar / 100) : 1;
			tD.style[p7BSE.prf + 'transform'] = 'scale(' + x + ')';
		} else if (op == 2) {
			x = (at) ? 1 : 1 + (ar / 100);
			tD.style[p7BSE.prf + 'transform'] = 'scale(' + x + ')';
		} else if (op > 2 && op < 11) {
			if (op == 3 || op == 7) {
				x = (at) ? 0 : ar * -1;
			} else if (op == 4 || op == 8) {
				x = (at) ? 0 : ar;
			} else if (op == 5 || op == 9) {
				y = (at) ? 0 : ar * -1;
			} else if (op == 6 || op == 10) {
				y = (at) ? 0 : ar;
			}
			tD.style[p7BSE.prf + 'transform'] = 'translate(' + x + '%,' + y + '%) scale(' + sc + ')';
		}
	}
}

function P7_BSEscroll_old(){
	var i, tt, tf, bf, tB, tD, br, wh, inView, op, pc, x, y, max, ph, sr, cs, ar, at, sc, ro;
	wh = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
	for (i = 0; i < p7BSE.ctl.length; i++) {
		inView = false;
		tB = p7BSE.ctl[i];
		if (tB.bseOnlyOnce) {
			continue;
		}
		tD = tB.bseOb;
		op = tB.bseOpt[2];
		ro = (tB.bseOpt[1] == 1) ? true : false;
		br = tD.parentNode.getBoundingClientRect();
		tt = br.top;
		ar = tB.bseOpt[3];
		tf = wh * (tB.bseOpt[4] / 100);
		bf = wh * (tB.bseOpt[5] / 100);
		sc = 1;
		if (op > 6 && op < 11) {
			sc = 1 + ((tB.bseOpt[3] * 2) / 100);
		}
		at = false;
		if (tt < (wh - bf)) {
			inView = true;
		}
		if (br.bottom < 0) {
			inView = false;
			at = true;
		}
		x = 0;
		y = 0;
		if (inView) {
			tB.bseOutView = false;
			pc = (tt - tf) / (wh - tf - bf);
			if (P7_BSEgetStyle(tD.parentNode, 'position') == 'fixed') {
				ph = document.body.parentNode.offsetHeight || document.body.offsetHeight;
				sr = ph - wh;
				cs = document.body.parentNode.scrollTop || document.body.scrollTop || window.scrollY || 0;
				pc = cs / sr;
				pc = 1 - pc;
			}
			if (op == 1) {
				x = 1 + (ar * (1 - pc)) / 100;
				max = 1 + (ar / 100);
				x = (x > max) ? max : x;
				tD.style[p7BSE.prf + 'transform'] = 'scale(' + x + ')';
				if (ro && x >= max) {
					tB.bseOnlyOnce = true;
				}
			} else if (op == 2) {
				x = 1 + (ar * pc) / 100;
				x = (x < 1) ? 1 : x;
				tD.style[p7BSE.prf + 'transform'] = 'scale(' + x + ')';
				if (ro && x == 1) {
					tB.bseOnlyOnce = true;
				}
			} else if (op > 2 && op < 11) {
				if (op == 3 || op == 7) {
					ar = ar * -1;
					x = ar * pc;
					x = (x > 0) ? 0 : x;
					x = (x < ar) ? ar : x;
					if (ro && x === 0) {
						tB.bseOnlyOnce = true;
					}
				} else if (op == 4 || op == 8) {
					x = ar * pc;
					x = (x < 0) ? 0 : x;
					x = (x > ar) ? ar : x;
					if (ro && x === 0) {
						tB.bseOnlyOnce = true;
					}
				} else if (op == 5 || op == 9) {
					ar = ar * -1;
					y = ar * pc;
					y = (y > 0) ? 0 : y;
					y = (y < ar) ? ar : y;
					if (ro && y === 0) {
						tB.bseOnlyOnce = true;
					}
				} else if (op == 6 || op == 10) {
					y = ar * pc;
					y = (y < 0) ? 0 : y;
					y = (y > ar) ? ar : y;
					if (ro && y === 0) {
						tB.bseOnlyOnce = true;
					}
				}
				tD.style[p7BSE.prf + 'transform'] = 'translate(' + x + '%,' + y + '%) scale(' + sc + ')';
			}
		} else if (!tB.bseOutView) {
			tB.bseOutView = true;
			if (op == 1) {
				x = (at) ? 1 + (ar / 100) : 1;
				tD.style[p7BSE.prf + 'transform'] = 'scale(' + x + ')';
			} else if (op == 2) {
				x = (at) ? 1 : 1 + (ar / 100);
				tD.style[p7BSE.prf + 'transform'] = 'scale(' + x + ')';
			} else if (op > 2 && op < 11) {
				if (op == 3 || op == 7) {
					x = (at) ? 0 : ar * -1;
				} else if (op == 4 || op == 8) {
					x = (at) ? 0 : ar;
				} else if (op == 5 || op == 9) {
					y = (at) ? 0 : ar * -1;
				} else if (op == 6 || op == 10) {
					y = (at) ? 0 : ar;
				}
				tD.style[p7BSE.prf + 'transform'] = 'translate(' + x + '%,' + y + '%) scale(' + sc + ')';
			}
		}
	}
}

function P7_BSEgetByAttribute(att, cls){
	var i, nL = [], aT, rS = [], cl, el;
	if (document.querySelectorAll) {
		nL = document.querySelectorAll('*[' + att + ']');
	} else {
		if (typeof(document.getElementsByClassName) != 'function') {
			aT = document.getElementsByTagName('*');
			for (i = 0; i < aT.length; i++) {
				cl = aT[i].className;
				if (cl && cl.indexOf(cls) > -1) {
					rS[rS.length] = aT[i];
				}
			}
		} else {
			rS = document.getElementsByClassName(cls);
		}
		for (i = 0; i < rS.length; i++) {
			if (rS[i].getAttribute(att)) {
				nL[nL.length] = rS[i];
			}
		}
	}
	return nL;
}

function P7_BSEsetClass(ob, cl){
	if (ob) {
		var cc, nc, r = /\s+/g;
		cc = ob.className;
		nc = cl;
		if (cc && cc.length > 0) {
			if (cc.indexOf(cl) == -1) {
				nc = cc + ' ' + cl;
			} else {
				nc = cc;
			}
		}
		nc = nc.replace(r, ' ');
		ob.className = nc;
	}
}

function P7_BSEremClass(ob, cl){
	if (ob) {
		var cc, nc;
		cc = ob.className;
		cl = cl.replace('-', '\-');
		var re = new RegExp('\\b' + cl + '\\b');
		if (re.test(cc)) {
			nc = cc.replace(re, '');
			nc = nc.replace(/\s+/g, ' ');
			nc = nc.replace(/\s$/, '');
			nc = nc.replace(/^\s/, '');
			if (nc === '' || nc === ' ') {
				ob.removeAttribute('class');
			} else {
				ob.className = nc;
			}
		}
	}
}

function P7_BSEgetCSSPre(){
	var i, dV, pre = ['animationDuration', 'WebkitAnimationDuration'];
	var c = 'none', cssPre = ['', '-webkit-'];
	dV = document.createElement('div');
	for (i = 0; i < pre.length; i++) {
		if (dV.style[pre[i]] !== undefined) {
			c = cssPre[i];
			break;
		}
	}
	return c;
}

function P7_BSEgetStyle(el, s){
	if (el.currentStyle) {
		s = el.currentStyle[s];
	} else if (document.defaultView && document.defaultView.getComputedStyle) {
		s = document.defaultView.getComputedStyle(el, "")[s];
	} else {
		s = el.style[s];
	}
	return s;
}
